// ------------------------------------------------------------
// oRtB^
// 
// Copyright (c) 2004 IMAGIRE Takashi. All rights reserved.
// ------------------------------------------------------------

// ------------------------------------------------------------
// eNX`
// ------------------------------------------------------------
sampler SrcSamp : register(s0);

float2 vSize;	// eNX`TCY
float2 d2u;		// UWQeNZ炷

// ------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// ------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos			: POSITION;
	float2 Tex0			: TEXCOORD0;
	float2 Tex1			: TEXCOORD1;
	float2 Tex2			: TEXCOORD2;
	float2 Tex3			: TEXCOORD3;
	float2 Tex4			: TEXCOORD4;
	float2 Tex5			: TEXCOORD5;
	float2 Tex6			: TEXCOORD6;
	float2 Tex7			: TEXCOORD7;
};

// ------------------------------------------------------------
// sNZVF[_vO
// ------------------------------------------------------------
float4 PS (VS_OUTPUT In) : COLOR
{   
#if 0
	// Catmull-Rom patch
    const float4 w3 = float4(-0.5, 1.5,-1.5, 0.5);
    const float4 w2 = float4( 1.0,-2.5, 2.0,-0.5);
    const float4 w1 = float4(-0.5, 0.0, 0.5, 0.0);
    const float4 w0 = float4( 0.0, 1.0, 0.0, 0.0);
#else
    const float4 w3 = float4(-1, 1,-1, 1);
    const float4 w2 = float4( 2,-2, 1,-1);
    const float4 w1 = float4(-1, 0, 1, 0);
    const float4 w0 = float4( 0, 1, 0, 0);
#endif
	
	float2 fUV = frac (In.Tex5 * vSize);	// TueNZ0`1̃p[^
	float2 fUV2 = fUV * fUV;				// fUV ̂Q
	float2 fUV3 = fUV * fUV2;				// fUV ̂R
	float4 u, v;
	u = fUV3.x * w3 + fUV2.x * w2 + fUV.x * w1 + w0;
	v = fUV3.y * w3 + fUV2.y * w2 + fUV.y * w1 + w0;
	
	// eNX`班炵ăTvO
	float4 col00 = tex2D( SrcSamp, In.Tex0 );
	float4 col01 = tex2D( SrcSamp, In.Tex1 );
	float4 col02 = tex2D( SrcSamp, In.Tex2 );
	float4 col03 = tex2D( SrcSamp, In.Tex3 );

	float4 col10 = tex2D( SrcSamp, In.Tex4 );
	float4 col11 = tex2D( SrcSamp, In.Tex5 );
	float4 col12 = tex2D( SrcSamp, In.Tex6 );
	float4 col13 = tex2D( SrcSamp, In.Tex7 );

	float4 col20 = tex2D( SrcSamp, In.Tex0 + d2u );
	float4 col21 = tex2D( SrcSamp, In.Tex1 + d2u );
	float4 col22 = tex2D( SrcSamp, In.Tex2 + d2u );
	float4 col23 = tex2D( SrcSamp, In.Tex3 + d2u );

	float4 col30 = tex2D( SrcSamp, In.Tex4 + d2u );
	float4 col31 = tex2D( SrcSamp, In.Tex5 + d2u );
	float4 col32 = tex2D( SrcSamp, In.Tex6 + d2u );
	float4 col33 = tex2D( SrcSamp, In.Tex7 + d2u );

	
	float4 col0 = u.x * col00 + u.y * col10 + u.z * col20 + u.w * col30;
	float4 col1 = u.x * col01 + u.y * col11 + u.z * col21 + u.w * col31;
	float4 col2 = u.x * col02 + u.y * col12 + u.z * col22 + u.w * col32;
	float4 col3 = u.x * col03 + u.y * col13 + u.z * col23 + u.w * col33;
	
    return v.x * col0 + v.y * col1 + v.z * col2 + v.w * col3;
}
// ------------------------------------------------------------
// eNjbN
// ------------------------------------------------------------
technique TShader
{
    pass P0
    {
        // VF[_
        PixelShader  = compile ps_2_0 PS();
    }
}
